#-----------------------------------------------------------------------------
# Fake GraspAndSpread
# June 22,2004
# Copyright (c) 2004, David G. Drumright [ockham]
#-----------------------------------------------------------------------------
import poser
import string

scene=poser.Scene()
SelActor=scene.CurrentActor()
# In this case we can't just assume the selected is the index.
Name=SelActor.Name()
UpName=string.upper(Name)
if not string.count(UpName,"INDEX"): raise "Must select Index 1 before using FakeSpread"

ActorsHand=SelActor.Parent()

# Spread, using the Yrot parm.
for F in range(scene.NumFrames()):
    scene.SetFrame(F)
    SelVal=SelActor.ParameterByCode(poser.kParmCodeYROT).Value()
    for Joint1 in ActorsHand.Children(): # Outer loop takes the first joint of each.
        # Modulate the side-side value of each.
        # The Mid gets half of the index; Ring gets -.5 of index; Pinky gets -1 of index.
        Name=Joint1.Name()
        UpName=string.upper(Name)
        if   string.count(UpName,"MID"):
            P=Joint1.ParameterByCode(poser.kParmCodeYROT)
            P.SetValue(SelVal * 0.5)
            P.AddKeyFrame()
        elif string.count(UpName,"RING"):
            P=Joint1.ParameterByCode(poser.kParmCodeYROT)
            P.SetValue(SelVal * -0.5)
            P.AddKeyFrame()
        elif string.count(UpName,"PINKY"):
            P=Joint1.ParameterByCode(poser.kParmCodeYROT)
            P.SetValue(SelVal * -1.0)
            P.AddKeyFrame()

# Grasp, using the Zrot parm.
for F in range(scene.NumFrames()):
    scene.SetFrame(F)
    SelBend=SelActor.ParameterByCode(poser.kParmCodeZROT).Value()
    for Joint1 in ActorsHand.Children(): # Outer loop takes the first joint of each.
        Name=Joint1.Name()
        UpName=string.upper(Name)
        if not string.count(UpName,"THUMB"):
            if not string.count(UpName,"CAMERA"):
                P=Joint1.ParameterByCode(poser.kParmCodeZROT)
                P.SetValue(SelBend)
                P.AddKeyFrame()
                for Joint2 in Joint1.Children():
                    P=Joint2.ParameterByCode(poser.kParmCodeZROT)
                    P.SetValue(SelBend)
                    P.AddKeyFrame()
                    for Joint3 in Joint2.Children():
                        P=Joint3.ParameterByCode(poser.kParmCodeZROT)
                        P.SetValue(SelBend)
                        P.AddKeyFrame()
scene.SetFrame(0) # For politeness
